/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.configurazione.bean;

import javax.persistence.Embeddable;

import org.hibernate.annotations.Parent;


@Embeddable
public class Field {

	private String name=null;
	private Operation operation=null;
	private String type=null;
	private String mappingScript=null;
	private String interfacePosition=null;

	
	public String getInterfacePosition() {
		return interfacePosition;
	}
	public void setInterfacePosition(String interfacePosition) {
		this.interfacePosition = interfacePosition;
	}
	
	public String getMappingScript() {
		return mappingScript;
	}
	public void setMappingScript(String mappingScript) {
		this.mappingScript = mappingScript;
	}
	public String getType() {
		return type;
	}
	public void setType(String type) {
		this.type = type;
	}

	@Parent
	public Operation getOperation() {
		return operation;
	}
	public void setOperation(Operation operation) {
		this.operation = operation;
	}

	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	
	public boolean equals(Object o) {
		if ( this == o ) return true;
		if ( o == null || getClass() != o.getClass() ) return false;

		final Field campo = (Field) o;

		if ( !name.equals( campo.getName().trim() ) ) return false;

		return true;
	}	

}
