/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.configurazione.service;

import it.eng.configurazione.bean.ConnetionParameter;
import it.eng.configurazione.bean.DataSource;
import it.eng.configurazione.bean.ExtractionProcess;
import it.eng.configurazione.bean.Field;
import it.eng.configurazione.bean.Interface;
import it.eng.configurazione.bean.Operation;
import it.eng.configurazione.bean.OperationParameter;
import it.eng.configurazione.bean.SourceType;

import java.util.List;

import org.hibernate.Query;
import org.hibernate.Session;

public class InsertJira {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Session sessione= HibernateUtils.getSession();
		
		Interface interfaccia1=new Interface();
		interfaccia1.setClassforname("it.eng.extractors.DefaultOperationCoordinator");
		interfaccia1.setName("INTERFACCIA_ANOMALIE");
		interfaccia1.setDescription("INTERFACCIA CHE CONTIENE I DATI DELLE ANOMALIE");
		interfaccia1.setXmlSchema("XML_SCHEMA");
		
		ExtractionProcess processo1=new ExtractionProcess();
		processo1.setInterfaceInfo(interfaccia1);
		processo1.setName("PROCESSO_JIRA");
		processo1.setDescription("PROCESSO DI ESTRAZIONE JIRA DI TEST");
				
		ConnetionParameter conP1=new ConnetionParameter();
		conP1.setName("URL");
		conP1.setValue("http://localhost:8080/rpc/soap/jirasoapservice-v2");
		ConnetionParameter conP2=new ConnetionParameter();
		conP2.setName("USER");
		conP2.setValue("bernabei");		
		ConnetionParameter conP3=new ConnetionParameter();
		conP3.setName("PASSWORD");
		conP3.setValue("angelo");	
		
		SourceType tipo1=new SourceType();
		tipo1.setName("JIRA");
		tipo1.setDescription("TIPOLOGIA DI SORGENTE JIRA");
		tipo1.setClassforname("it.eng.extractor.jira.JiraExtractor");
		
		DataSource ds=new DataSource();
		ds.setDescription("DATA SOURCE JIRA DI TEST");
		ds.setName("DS_JIRA_TEST");
		ds.setSource(tipo1);
		ds.addParameter(conP1);
		ds.addParameter(conP2);
		ds.addParameter(conP3);

		
		Operation operazione1=new Operation();
		operazione1.addProcess(processo1);
		operazione1.setName("BUG_EXTRACTION");
		operazione1.setDataSource(ds);
		//processo1.addOperation(operazione1);
		
		
		Field campo1=new Field();
		campo1.setInterfacePosition("testCase");
		campo1.setName("testCase");
		campo1.setType("Stringa");
		
		Field campo2=new Field();
		campo2.setName("effort");
		campo2.setInterfacePosition("effort");
		campo2.setType("Integer");
		
		Field campo3=new Field();
		campo3.setName("phase");
		campo3.setInterfacePosition("phase");
		campo3.setType("Stringa");	
		
		Field campo4=new Field();
		campo4.setName("componentName");
		campo4.setInterfacePosition("componentName");
		campo4.setType("Stringa");	
		
		Field campo5=new Field();
		campo5.setName("status");
		campo5.setInterfacePosition("status");
		campo5.setMappingScript("if (input==\"1\"){return \"OPEN\";} "+
				" else if (input==\"3\"){return \"IN_PROGRESS\";} " +
				" else if (input==\"4\"){return \"REOPENED\";} " +
				" else if (input==\"5\"){return \"RESOLVED\";} " +
	            " else if (input==\"6\"){return \"CLOSED\";} ");
		campo5.setType("Stringa");	
		
		Field campo6=new Field();
		campo6.setName("resolution");
		campo6.setInterfacePosition("resolution");
		campo6.setMappingScript("if (input==\"1\"){return \"FIXED\";} "+
				" else if (input==\"2\"){return \"WON'T FIXED\";} " +
				" else if (input==\"3\"){return \"DUPLICATE\";} " +
				" else if (input==\"4\"){return \"INCOMPLETE\";} " +
	            " else if (input==\"5\"){return \"CANNOT REPRODUCE\";} ");
		campo6.setType("Stringa");	
		
		Field campo7=new Field();
		campo7.setName("priority");
		campo7.setInterfacePosition("priority");
		campo7.setMappingScript("if (input==\"1\"){return \"BLOCKER\";} "+
				" else if (input==\"2\"){return \"CRITICAL\";} " +
				" else if (input==\"3\"){return \"MAJOR\";} " +
				" else if (input==\"4\"){return \"MINOR\";} " +
	            " else if (input==\"5\"){return \"TRIVIAL\";} ");
		campo7.setType("Stringa");	
		
		Field campo8=new Field();
		campo8.setName("type");
		campo8.setInterfacePosition("type");
		campo8.setMappingScript("if (input==\"1\"){return \"BUG\";} "+
				" else if (input==\"2\"){return \"NEW_FEATURES\";} " +
				" else if (input==\"3\"){return \"TASK\";} " +
	            " else if (input==\"4\"){return \"IMPROVEMENT\";} ");
		campo8.setType("Stringa");		
		
		OperationParameter parField1=new OperationParameter();
		parField1.setName("CUSTOM_FIELD.testCase");
		parField1.setValue("customfield_10000");
		
		OperationParameter parField2=new OperationParameter();
		parField2.setName("CUSTOM_FIELD.componentName");
		parField2.setValue("customfield_10003");
		
		OperationParameter parField3=new OperationParameter();
		parField3.setName("CUSTOM_FIELD.effort");
		parField3.setValue("customfield_10003");	
		
		OperationParameter parField4=new OperationParameter();
		parField4.setName("CUSTOM_FIELD.phase");
		parField4.setValue("customfield_10003");
		
		OperationParameter parField5=new OperationParameter();
		parField5.setName("PROJECTS");
		parField5.setValue("TEST");
		
		OperationParameter parField6=new OperationParameter();
		parField6.setName("FILTER");
		parField6.setValue("test");		
		
		operazione1.addField(campo1);
		operazione1.addField(campo2);
		operazione1.addField(campo3);
		operazione1.addField(campo4);
		operazione1.addField(campo5);
		operazione1.addField(campo6);
		operazione1.addField(campo7);
		operazione1.addField(campo8);		
		operazione1.addParameter(parField1);
		operazione1.addParameter(parField2);
		operazione1.addParameter(parField3);
		operazione1.addParameter(parField4);
		operazione1.addParameter(parField5);
		operazione1.addParameter(parField6);
		
		sessione.beginTransaction();

		sessione.save(interfaccia1);
		sessione.save(processo1);
		sessione.save(tipo1);
		sessione.save(ds);		
		sessione.save(operazione1);		

		sessione.getTransaction().commit();
		

	}

}
