package it.eng.configurazione.bean;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.Table;

@Entity
@Table(name="dt_kpi")
public class Kpi {

	private int id;
	private String name=null;
	private String documentLabel=null;
	private int min;
	private int max;
	private Set<MeasurableAttribute> measurableAttributes=new HashSet<MeasurableAttribute>();	
	
	@Column( nullable = true,name="document_label")
	public String getDocumentLabel() {
		return documentLabel;
	}
	public void setDocumentLabel(String documentLabel) {
		this.documentLabel = documentLabel;
	}
	
	@Column( nullable = false,unique=true,name="id_kpi")
	@Id
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	@Column( nullable = true,name="max_value")
	public int getMax() {
		return max;
	}
	public void setMax(int max) {
		this.max = max;
	}
	@Column( nullable = true,name="min_value")
	public int getMin() {
		return min;
	}
	public void setMin(int min) {
		this.min = min;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	@ManyToMany(
			cascade={CascadeType.PERSIST, CascadeType.MERGE},
			targetEntity=MeasurableAttribute.class
			)
	@JoinTable(
			name="dt_kpi_measurable_attribute",
			joinColumns={@JoinColumn(name="id_kpi")},
			inverseJoinColumns={@JoinColumn(name="id_measurable_attribute")}
			)
	public Set<MeasurableAttribute> getMeasurableAttributes() {
		return measurableAttributes;
	}
	public void setMeasurableAttributes(
			Set<MeasurableAttribute> measurableAttributes) {
		this.measurableAttributes = measurableAttributes;
	}
	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + id;
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final Kpi other = (Kpi) obj;
		if (id != other.id)
			return false;
		return true;
	}
}
