package it.eng.configurazione.test;

import org.hibernate.Session;

import it.eng.configurazione.bean.Interface;
import it.eng.configurazione.service.ConfigurationDAO;
import it.eng.configurazione.service.HibernateUtils;
import junit.framework.TestCase;

public class InterfaceTest extends TestCase {

	Interface interfacciaTest=null;
	Session sessione= HibernateUtils.getSession();
	public InterfaceTest(String name) {
		super(name);
		
	}

	protected void setUp() throws Exception {
		
		

		interfacciaTest=new Interface();
		interfacciaTest.setClassforname("it.eng.test.managerImpl.class");
		interfacciaTest.setName("Interfaccia_Requisiti");
		interfacciaTest.setDescription("Questa interfaccia definisce tutti i campi dei requisiti");
		interfacciaTest.setXmlSchema("<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?><xs:schema xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" elementFormDefault=\"qualified\" attributeFormDefault=\"unqualified\" targetNamespace=\"http://egov.diviana.it/Fiscali\" xmlns=\"http://egov.diviana.it/Fiscali\" xmlns:OggettiCondivisi=\"http://egov.diviana.it/OggettiCondivisi\" xmlns:DocumentiUfficiali=\"http://egov.diviana.it/DocumentiUfficiali\"><xs:annotation><xs:documentation>Copyright Diviana sas 2002-2004 - Prodotto da Diviana sas  per conto di Progetto People</xs:documentation><xs:documentation>Tutti i diritti riservati</xs:documentation></xs:annotation><xs:import namespace=\"http://egov.diviana.it/DocumentiUfficiali\" schemaLocation=\"DocumentiUfficiali.xsd\"/><xs:import namespace=\"http://egov.diviana.it/OggettiCondivisi\" schemaLocation=\"OggettiCondivisi.xsd\"/><xs:complexType name=\"RichiestadiProvvedimentiICIEmessiVersoilContribuenteconDettagliodiSanzionieInteressi\"><xs:complexContent><xs:extension base=\"OggettiCondivisi:RichiestadiServizioOnLineallaPA\"><xs:sequence><xs:element name=\"CartelladiProvvedimentiICI\" type=\"CartelladiProvvedimentiICI\"/></xs:sequence></xs:extension></xs:complexContent></xs:complexType><xs:complexType name=\"CartelladiProvvedimentiICI\"><xs:complexContent><xs:extension base=\"OggettiCondivisi:Risposta\"><xs:sequence><xs:element name=\"CartelladiProvvedimentiICI\" type=\"DocumentiUfficiali:CartelladiProvvedimentiICI\"/><xs:element name=\"ProvvedimentoICI\" type=\"ProvvedimentoICI\" minOccurs=\"0\" maxOccurs=\"unbounded\"/></xs:sequence></xs:extension></xs:complexContent></xs:complexType><xs:complexType name=\"Provvedimento\" abstract=\"true\"><xs:sequence><xs:element name=\"AnnodiApplicazione\" type=\"OggettiCondivisi:Anno\"/><xs:element name=\"CodiceFiscale\" type=\"OggettiCondivisi:CodiceFiscale\"/><xs:element name=\"DatadelProvvedimento\" type=\"OggettiCondivisi:Data\"/><xs:element name=\"Stato\" type=\"Stato\"/><xs:element name=\"DifferenzatraDovutoeVersato\" type=\"OggettiCondivisi:Importo\" minOccurs=\"0\"/><xs:element name=\"Sanzioni\" type=\"OggettiCondivisi:Importo\" minOccurs=\"0\"/><xs:element name=\"Interessi\" type=\"OggettiCondivisi:Importo\" minOccurs=\"0\"/><xs:element name=\"Spese\" type=\"OggettiCondivisi:Importo\" minOccurs=\"0\"/><xs:element name=\"ImportoTotale\" type=\"OggettiCondivisi:Importo\"/><xs:element name=\"ImportoVersato\" type=\"OggettiCondivisi:Importo\" minOccurs=\"0\"/></xs:sequence></xs:complexType><xs:simpleType name=\"Stato\"><xs:restriction base=\"xs:string\"><xs:enumeration value=\"Emesso\"/><xs:enumeration value=\"Notificato\"/><xs:enumeration value=\"Sospeso\"/><xs:enumeration value=\"Pagato\"/><xs:enumeration value=\"Annullato\"/><xs:enumeration value=\"A Ruolo Coattivo\"/></xs:restriction></xs:simpleType><xs:complexType name=\"ProvvedimentoICI\"><xs:complexContent><xs:extension base=\"Provvedimento\"><xs:sequence><xs:element name=\"TipodiProvvedimentoICI\" type=\"TipodiProvvedimentoICI\"/><xs:element name=\"IdentificatorediProvvedimentoICI\" type=\"IdentificatorediProvvedimentoICI\"/></xs:sequence></xs:extension></xs:complexContent></xs:complexType><xs:simpleType name=\"TipodiProvvedimentoICI\"><xs:restriction base=\"xs:string\"><xs:enumeration value=\"Accertamento\"/><xs:enumeration value=\"Liquidazione\"/><xs:enumeration value=\"Rimborso\"/><xs:enumeration value=\"Rateizzazione del Pagamento\"/><xs:enumeration value=\"Annullamento\"/><xs:enumeration value=\"Irrogazione di Sanzione Generica\"/></xs:restriction></xs:simpleType><xs:complexType name=\"IdentificatorediProvvedimentoICI\"><xs:complexContent><xs:extension base=\"OggettiCondivisi:Identificatore\"/></xs:complexContent></xs:complexType></xs:schema>");
		
		sessione.beginTransaction();
		sessione.save(interfacciaTest);
		sessione.getTransaction().commit();
	}

	protected void tearDown() throws Exception {

		sessione.beginTransaction();
		sessione.delete(interfacciaTest);
		sessione.getTransaction().commit();		
	}

	/**
	 * test di lettura della configurazione
	 *
	 */
	public void testLetturaInterfaccia() {
		ConfigurationDAO dao=new ConfigurationDAO();
		Interface interfaccia=dao.readInterface("Interfaccia_Requisiti");
		assertEquals(interfaccia.getName(), interfacciaTest.getName());
		assertEquals(interfaccia.getDescription(), interfacciaTest.getDescription());
		assertEquals(interfaccia.getClassforname(), interfacciaTest.getClassforname());
		assertEquals(interfaccia.getId(), interfacciaTest.getId());
		assertEquals(interfaccia.getXmlSchema(), interfacciaTest.getXmlSchema());
		
	}

}
